/* ez-blob-tagz.h: A tagged blob serialiser.

   Copyright (C) 2019 Michael Zucchi

   This program is free software: you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public License
   as published by the Free Software Foundation, either version 3 of
   the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this program. If not, see
   <http://www.gnu.org/licenses/>.
*/


#ifndef _EZ_BLOB_TAGZ_H
#define _EZ_BLOB_TAGZ_H

size_t ez_tagz_size(const ez_blob_desc *d, const void *p);

int ez_tagz_encode_raw(const ez_blob_desc *d, const void *p, ez_blob *blob);
int ez_tagz_encode(const ez_blob_desc *d, const void *p, ez_blob *blob);

int ez_tagz_decode_raw(const ez_blob_desc *desc, const ez_blob *blob, void *p);
void *ez_tagz_decode(const ez_blob_desc *desc, const ez_blob *blob);

#endif
